#include "racing.h"

#include "glut.h"
#include "drawtools.h"
#define _USE_MATH_DEFINES
#include <math.h>

RaceTrack::RaceTrack()
{

	_InsideTrack = new dlist;
	_OutsideTrack = new dlist;

	_EditMode = TRACK_EDIT_OFF;

}

RaceTrack::~RaceTrack()
{
	delete _InsideTrack;
	delete _OutsideTrack;
}

void RaceTrack::LoadTrack()
{
	//Implement this yourself
}

void RaceTrack::SaveTrack()
{
	//Implement this yourself
}

void RaceTrack::DrawTrack()
{
	//Implement this yourself
}

void RaceTrack::AddVertex(int x,int y)
{
	//Implement this yourself
}

void RaceTrack::CloseTrack(int x, int y)
{
	//Implement this yourself
}

RaceCar::RaceCar()
{
	//Implement this yourself
}

RaceCar::~RaceCar()
{
}

void RaceCar::UpdatePosition(RaceTrack * Track)
{
	float clr[3]={1.0,0.0,0.0};
	bool Collided = false,loop=true;

	//Calculate the position of the car bumper
	_bumperpos[0] = _pos[0] + (_length/2)*cos((90 - _angle)*DEG2RAD);
	_bumperpos[1] = _pos[1] + (_length/2)*sin((90 - _angle)*DEG2RAD);

	while(loop)
	{
		//Check for collisions with the track
		dlist::ITER iter(Track->_OutsideTrack);		// the object is called iter
		line* itemptr = 0;
		while((itemptr = (line*)iter.next()) != 0)		// the while stops if n == 0
		{
			//Check for a collision
			if(Collision(itemptr))
			{
				//Stoppen met while lus: alleen eerste collision telt
				Collided = true;
				_damage++;
				break;
			}
		}
		if(Collided)
			break;

		//Check for collisions with the track
		dlist::ITER iter2(Track->_InsideTrack);		// the object is called iter
		while((itemptr = (line*)iter2.next()) != 0)		// the while stops if n == 0
		{
			//Check for a collision
			if(Collision(itemptr))
			{
				//Stoppen met while lus: alleen eerste collision telt
				Collided = true;
				_damage++;
				break;
			}
		}
		loop=false;
	}
	//Update the position using the new angle if a collision occured or the old angle if no collision occured
	_pos[0] = _pos[0] + _v*cos((90 - _angle)*DEG2RAD);
	_pos[1] = _pos[1] + _v*sin((90 - _angle)*DEG2RAD);
	if(_pos[0]<0)
		_pos[0]=0;
	if(_pos[0]>WIDTH)
		_pos[0]=WIDTH;
	if(_pos[1]<0)
		_pos[1]=0;
	if(_pos[1]>HEIGHT)
		_pos[1]=HEIGHT;
}

bool RaceCar::Collision(line * TrackSide)
{
	float x1, x2, y1, y2,theta,delta1,delta2;
	float intersection_point[2];

	x1 = TrackSide->_p1[0];
	y1 = TrackSide->_p1[1];
	x2 = TrackSide->_p2[0];
	y2 = TrackSide->_p2[1];
	theta = RAD2DEG*atan2( (x2-x1),(y2-y1) );	//Angle of the trackside to the line x=x1
	theta = normalize(theta);
	
	_angle = _angle;					//Angle of the car to the line x=_pos[0]

	if(theta == _angle || abs(theta - _angle) == 180)
		return false;					//Unique case, car is parallel to the track side: no collision

	//Calculate where the lines would intersect if they both were infinitely long
	intersection_point[0] = (x1*tan(DEG2RAD*(90-theta))-_pos[0]*tan(DEG2RAD*(90-_angle))+_pos[1]-y1)/(tan(DEG2RAD*(90-theta))-tan(DEG2RAD*(90-_angle)));
	intersection_point[1] = tan(DEG2RAD*(90-theta))*(intersection_point[0]-x1)+y1;
	
	//Check whether the calculated intersection point is on both lines
	if(between(intersection_point[0], x1, x2) && between(intersection_point[0],_pos[0],_bumperpos[0]))
	{
		//The new car direction will be parallel to the wall
		delta1=abs(theta-_angle);
		delta2=abs(normalize(theta+180)-_angle);
		_angle = delta1 < delta2 ? theta : theta+180;

		_angle = normalize(_angle);
		_v = _v/2;						//This slows the car down after a collision
		return true;
	}

	return false;
}


void RaceCar::Draw()
{
	//Implement this yourself
}

void RaceCar::SpeedUp(float Amount)
{
	//Implement this yourself
}

void RaceCar::SlowDown(float Amount)
{
	//Implement this yourself
}

void RaceCar::TurnLeft()
{
	//Implement this yourself
}

void RaceCar::TurnRight()
{
	//Implement this yourself
}

//Helper function for the collision detection
bool between(float num, float border1, float border2)
{
	if(border2 > border1)
		if(num > border1 && num < border2)
			return true;
		else
			return false;
	else
		if(num > border2 && num < border1)
			return true;
		else
			return false;
}

//Modifies the input angle until it lies between 0 and 360
float normalize(float angle)
{
	while(angle>=360) angle-=360;
	while(angle<0)   angle+=360;

	return angle;
}