//Race game special functions and classes


#ifndef RACING_H
#define RACING_H

#include "dlist.h"
#include "drawtools.h"

#define TRACK_EDIT_OFF 0
#define TRACK_EDIT_INSIDE 1
#define TRACK_EDIT_OUTSIDE 2
#define DEG2RAD M_PI/180
#define RAD2DEG 180/M_PI

bool between(float num, float border1, float border2);
float normalize(float angle);

class RaceTrack
{
public:
	RaceTrack();
	~RaceTrack();
	void LoadTrack();				//Load a complete track (inside and outside) from an EDIF++ file
	void SaveTrack();				//Save a complete track (inside and outside) to an EDIF++ file
	void DrawTrack();
	void AddVertex(int x,int y);	//Adds a trackside to the track being currently edited
	void CloseTrack(int x, int y);	//Adds the last vertex to the track, closing it

	dlist *_InsideTrack;			//This is the left hand side of the racetrack
	dlist *_OutsideTrack;			//This is the right hand side of the racetrack

	int _EditMode;					//Shows if the track editor is enabled and whether it is the inside or outside track that is being edited
};

class RaceCar
{
public:
	RaceCar();
	~RaceCar();

	void UpdatePosition(RaceTrack * Track);
	bool Collision(line * TrackSide);
	void Draw();
	void SpeedUp(float Amount);
	void SlowDown(float Amount);
	void TurnLeft();
	void TurnRight();

	float _pos[2];
	float _bumperpos[2];
	float _v;
	float _max_speed;
	float _turn_rate;
	float _angle;
	float _length;
	float _width;
	float _color[3];
	unsigned int _damage;
};




#endif